package wang.app.gradebook;

import javax.swing.*;
import java.awt.*;

public class RecordInputPane {
    
         class DigitsOnlyVerifier extends InputVerifier {
         public boolean verify(JComponent input) {
             JTextField tf = (JTextField) input;
             return tf.getText().matches("[0-9]+");
         }
     }

    static final int hGap = 5, vGap = 1;
    Component parent = null;
    String    title = null;

    JPanel pane = new JPanel();
    JTextField txts[] = null;
    String values[] = null;   
    DigitsOnlyVerifier dVerifier = new DigitsOnlyVerifier();
   
    public RecordInputPane ( Component parent,  String title, String recFieldNames[] ) {
	String defValues [] = new String[recFieldNames.length];
	for ( int i = 0; i < recFieldNames.length; i ++ ) defValues[i] = "";
	setup( parent, title, recFieldNames, defValues);
    }

    public RecordInputPane ( Component parent,  String title, String recFieldNames[], String []  defValues )
    {  setup( parent, title, recFieldNames, defValues);  }

    void setup ( Component parent,  String title, String recFieldNames[],  String defValues[] ) {
	this.parent = parent;
	this.title = title;

	txts = new JTextField[recFieldNames.length];
	values = new String[recFieldNames.length];

	pane.setLayout( new GridLayout( recFieldNames.length, 2, hGap, vGap) );

	for ( int i = 0; i < recFieldNames.length; i ++ ) {
		pane.add( new JLabel ( recFieldNames[i], SwingConstants.RIGHT ) );
		txts[i] = new JTextField(defValues[i], 10);
                if ( i >= 0 && i <= 2 || i == 5 ) txts[i].setInputVerifier(dVerifier);
		pane.add( txts[i] );
	
	}

    }

    String [] getRecord() {

	String options[] = {"Add", "Cancel" };

	int choice = JOptionPane.showOptionDialog(parent, pane, title, JOptionPane.YES_NO_OPTION,
			JOptionPane.PLAIN_MESSAGE, null, options, null);

	if ( choice != JOptionPane.YES_OPTION ) return null;

	for ( int i = 0; i < txts.length; i ++ ) values[i] = txts[i].getText();

	return values;
   };
}
